/*****************************************************************
* Copyright (c) 2020 Lenovo Group. All rights reserved.
* Redistribution and use in source and binary forms, with or without modification,
* is not permitted without specific prior written permission from Lenovo.
*
* File Name:
dynamicLocale.js
* Description:
Get the local files content dynamically
parameters:
key: the resource key
params: the resource object
return:
the resource content
getLocale("helloParam",{first:value1,second:value2});
* Author：
hanlj
* Change log
*********************************************************************/
 define(function(require, exports, module) {
	exports.getJSLocale = function (key,params){
		 var result = ""; 	    // used to indicate the resource
			var paramsObj = {};	// Parameter object
			if(params){
			    paramsObj = params;
			}

			if(typeof(key) != 'undefined' && typeof(JSLocale) != 'undefined'){
				// Get the value based on Key
				if(JSLocale[key] != undefined){
					result = JSLocale[key];
				}else{
					result = key;
				}

				// Use the value instead of the parameter
				var regExp = new RegExp();
				for(var k in paramsObj){
					regExp = "{{:" + k + "}}";
					result = result.replace(regExp,paramsObj[k]);
				}

				// If not find the related resource, then return "No Value"
				if(/{{:[a-zA-Z]+}}/.test(result)){
					result = result.replace(/{{:[a-zA-Z]+}}/g, "No Value");
				}
			}
			return result;
	 };

});
