(function ($, window, document) {
    "use strict";
    var _globalWalkthrough = {}, _elements = [], _activeWalkthrough, _activeId, _hasDefault = true, _counter = 0,
        _isCookieLoad, _firstTimeLoad = true, _onLoad = true, _index = 0, _isWalkthroughActive = false,
        $jpwOverlay = $('<div id="jpwOverlay"></div>'),
        $jpWalkthrough = $('<div id="jpWalkthrough"></div>'),
        $jpwTooltip = $('<div id="jpwTooltip"></div>');
    var methods = {
        isActive: function () {
            return !!_isWalkthroughActive;
        }, index: function (value) {
            if (typeof value !== "undefined") {
                _index = value;
            }
            return _index;
        }, init: function (options) {
            options = $.extend(true, {}, $.fn.pagewalkthrough.defaults, options);
            var that = this;
            if (!options.name) {
                throw new Error("Must provide a unique name for a tour");
            }
            this.first().data("jpw", options);
            options._element = this;
            return this.each(function (i) {
                options = options || {};
                options.elementID = options.name;
                _globalWalkthrough[options.name] = options;
                _elements.push(options.name);
                if (options.onLoad) {
                    _counter++;
                }
                if (_counter === 1 && _onLoad) {
                    _activeId = options.name;
                    _activeWalkthrough = _globalWalkthrough[_activeId];
                    _onLoad = false;
                }
                if (i + 1 === that.length && _counter === 0) {
                    _activeId = options.name;
                    _activeWalkthrough = _globalWalkthrough[_elements[0]];
                    _hasDefault = false;
                }
            });
        }, renderOverlay: function () {
            if (_counter > 1) {
                debug("Warning: Only 1st walkthrough will be shown onLoad as default");
            }
            _isCookieLoad = getCookie("_walkthrough-" + _activeId);
            if (typeof _isCookieLoad === "undefined") {
                _isWalkthroughActive = true;
                if (!onEnter()) {
                    return;
                }
                showStep();
                showButton("jpwClose", "body");
                setTimeout(function () {
                    if (isFirstStep() && _firstTimeLoad) {
                        if (!onAfterShow()) {
                            return;
                        }
                    }
                }, 100);
            } else {
                onCookieLoad(_globalWalkthrough);
            }
        }, restart: function (e) {
            if (isFirstStep()) {
                return;
            }
            _index = 0;
            if (!onRestart(e)) {
                return;
            }
            if (!onEnter(e)) {
                return;
            }
            showStep();
        }, close: function () {
            // Set firstLcpUG=1
            setCookie("firstLcpUG", 1, 365);
//            window.location.href = window.document.location.href;
             window.location.reload();
            var options = _activeWalkthrough;
            onLeave();
            if (typeof options.onClose === "function") {
                options.onClose.call(this);
            }
            _index = 0;
            _firstTimeLoad = true;
            _isWalkthroughActive = false;
            setCookie("_walkthrough-" + _activeId, 0, 365);
            _isCookieLoad = getCookie("_walkthrough-" + _activeId);
            $jpwOverlay.fadeOut("slow", function () {
                $(this).remove();
            });
            $jpWalkthrough.fadeOut("slow", function () {
                $(this).html("").remove();
            });
            $("#jpwClose").fadeOut("slow", function () {
                $(this).remove();
            });
        }, show: function (name, e) {
            e = name == null ? name : e;
            name = name || this.first().data("jpw").name;
            _activeWalkthrough = _globalWalkthrough[this.first().data("jpw").name];
            if (name === _activeId && _isWalkthroughActive || !onEnter(e)) {
                return;
            }
            _isWalkthroughActive = true;
            _firstTimeLoad = true;
            if (!onBeforeShow()) {
                return;
            }
            showStep();
            showButton("jpwClose", "body");
            if (isFirstStep() && _firstTimeLoad) {
                if (!onAfterShow()) {
                    return;
                }
            }
        }, next: function (e) {
            if (_index === 1){
                // open serversList
                document.getElementById("serverline").click();
//                console.log(_index,"need click server list show all servers");
            }else if(_index === 2){
                // add server to area(Double click), close serversList
                $(".stepAddServer",parent.document).trigger("dblclick");
                document.getElementById("serverline").click();
//                console.log(_index,"need click add server show picture");
            }else if(_index === 3){
                // click Configure to open configuration page
                $("#alone_server_config",parent.document).trigger("mouseup");
//                console.log(_index,"need click configuration button show configurepage");
            }else if(_index === 4){
                // click OK to close configuration page
                document.getElementById("configServerButtonOK").click();
//                console.log(_index,"need click close configure && special toolbar");
            }else if(_index === 5){
                // open save toolbar
                document.getElementById("save_import").click();
//                console.log(_index,"need click toobar id3 show save && export");
            }else if(_index === 6){
                // open import toolbar
                document.getElementById("title").click();
                document.getElementById("open_export").click();
//                console.log(_index,"need click toobar id2 show import");
            }else if(_index === 7){
                // open about toolbar
                document.getElementById("title").click();
                document.getElementById("help_about").click();
//                console.log(_index,"need click toobar id5 show about");
            }
            _firstTimeLoad = false;
            if (isLastStep()) {
                return;
            }
            if (!onLeave(e)) {
                return;
            }
            _index = parseInt(_index, 10) + 1;
            if (!onEnter(e)) {
                methods.next();
            }
            showStep("next");
        }, prev: function (e) {
            if (_index === 2){
                // close serversList
                document.getElementById("serverline").click();
//                console.log("need click server list show all servers");
            }else if (_index === 3){
                // delete server(click Delete), open servers list
                document.getElementById("delete_alone_server").click();
                document.getElementById("confirmbtnok").click();
                document.getElementById("serverline").click();
//                console.log("need click server list show all servers");
            }else if(_index === 4){
                // click OK to close configuratipn page
                document.getElementById("configServerButtonOK").click();
//                console.log(_index,"need click add server show picture");
            }else if(_index === 5){
                // click Configure to open configuration page
                $("#alone_server_config",parent.document).trigger("mouseup");
//                console.log(_index,"need click configuration button show configurepage");
            }else if(_index === 6){
                // click Title to close save toolbar
                document.getElementById("title").click();
//                console.log(_index,"need click close configure && special toolbar");
            }else if(_index === 7){
                // click Title to close import toolbar, open save toolbar
                document.getElementById("title").click();
                document.getElementById("save_import").click();
//                console.log(_index,"need click toobar id3 show save && export");
            }else if(_index === 8){
                // click Title to close abouot toolbar, open import toolbar
                document.getElementById("title").click();
                document.getElementById("open_export").click();
//                console.log(_index,"need click toobar id2 show import");
            }
            if (isFirstStep()) {
                return;
            }
            if (!onLeave(e)) {
                return;
            }
            _index = parseInt(_index, 10) - 1;
            if (!onEnter(e)) {
                methods.prev();
            }
            showStep("prev");
        }, getOptions: function (activeWalkthrough) {
            var _wtObj;
            if (activeWalkthrough) {
                _wtObj = {};
                _wtObj = _activeWalkthrough;
            } else {
                _wtObj = [];
                for (var wt=0; wt<_globalWalkthrough.length; wt++) {
                    _wtObj.push(_globalWalkthrough[wt]);
                }
            }
            return _wtObj;
        }, refresh: function () {
            showStep("next");
        }
    };

    function showStep(skipDirection) {
        var options = _activeWalkthrough, step = options.steps[_index],
            targetElement = options._element.find(step.wrapper), scrollTarget = getScrollParent(targetElement),
            maxScroll, scrollTo;
        if (step.popup.type !== "modal" && !targetElement.length) {
            if (step.popup.fallback === "skip" || typeof step.popup.fallback === "undefined") {
                methods[skipDirection]();
                return;
            }
            step.popup.type = step.popup.fallback;
        }
        maxScroll = scrollTarget[0].scrollHeight - scrollTarget.outerHeight();
        scrollTo = step.popup.type === "modal" ? 0 : Math.floor(targetElement.offset().top - $(window).height() / 2 + scrollTarget.scrollTop());
        if (scrollTarget.scrollTop() !== scrollTo && (scrollTarget.scrollTop() === maxScroll && scrollTo < maxScroll || scrollTo <= 0 && scrollTarget.scrollTop() > 0 || scrollTo > 0)) {
            $jpWalkthrough.addClass("jpw-scrolling");
            $jpwTooltip.fadeOut("fast");
            scrollTarget.animate({scrollTop: scrollTo}, options.steps[_index].scrollSpeed, buildWalkthrough);
        } else {
            buildWalkthrough();
        }
    }

    function buildWalkthrough() {
        $jpWalkthrough.removeClass("jpw-scrolling");
        var options = _activeWalkthrough, step = options.steps[_index], targetElement, scrollParent, maxHeight;
        options.steps[_index] = $.extend(true, {}, $.fn.pagewalkthrough.defaults.steps[0], step);
        targetElement = options._element.find(step.wrapper);
        scrollParent = getScrollParent(targetElement);
        $jpwOverlay.show();
        if (step.popup.type !== "modal" && step.popup.type !== "nohighlight") {
            $jpWalkthrough.html("");
            if (step.wrapper === "" || typeof step.wrapper === "undefined") {
                debug('Your walkthrough position is: "' + step.popup.type + '" but wrapper is empty or undefined. Please check your "' + _activeId + '" wrapper parameter.');
                return;
            }
            maxHeight = scrollParent.outerHeight() - targetElement.offset().top + scrollParent.offset().top + scrollParent.scrollTop();
            maxHeight = maxHeight <= 0 ? targetElement.outerHeight() : maxHeight;
            $jpwOverlay.appendTo($jpWalkthrough);
            var top1,left1,addWid=0,addHeih=0,back,idname;
            switch (step.popup.content) {
                case "#walkthrough-1":
                    top1 = "-600px";
                    left1 = "-30px";
                    back = "none";
                    idname = 'overlay-hole';
                    break;
                case "#walkthrough-2":
                    top1 = "-420px";
                    left1 = "-30px";
                    back = "none";
                    idname = 'overlay-hole';
                    break;
                case "#walkthrough-3":
                    top1 = "-420px";
                    left1 = "250px";
                    addWid = 25;
                    back = "none";
                    idname = 'overlay-hole3';
                    if(document.documentElement.clientWidth>1600){
                        left1 = "330px";
                    }
                    break;
                case "#walkthrough-4":
                    top1 = "-630px";
                    left1 = "-60px";
                    addHeih = 75;
                    back = "radial-gradient(#333333, transparent)";
                    idname = 'overlay-hole4';
                    if(document.documentElement.clientWidth>1600){
                        left1 = "20px";
                    }
                    break;
                case "#walkthrough-5":
                    top1 = "-640px";
                    left1 = "730px";
                    addWid = -30;
                    back = "none";
                    idname = 'overlay-hole5';
                    if(document.documentElement.clientWidth>1600){
                        left1 = "900px";
                    }
                    break;
                case "#walkthrough-6":
                    top1 = "-590px";
                    left1 = "760px";
                    addWid = -80;
                    addHeih = -50;
                    back = "none";
                    idname = 'overlay-hole6';
                    if(document.documentElement.clientWidth>1600){
                        left1 = "920px";
                    }
                    break;
                case "#walkthrough-7":
                    top1 = "-540px";
                    left1 = "720px";
                    back = "none";
                    idname = 'overlay-hole7';
                    if(document.documentElement.clientWidth>1600){
                        left1 = "870px";
                    }
                    break;
                case "#walkthrough-8":
                    top1 = "-535px";
                    left1 = "855px";
                    back = "none";
                    idname = 'overlay-hole8';
                    if(document.documentElement.clientWidth>1600){
                        left1 = "1010px";
                    }
                    break;
            }

            $("<div id="+idname+">").addClass("overlay-hole").height(Math.min(maxHeight, targetElement.outerHeight()) + addHeih).width(targetElement.outerWidth() + addWid).css({
                padding: "20px",
                position: "relative",
                // top: targetElement.offset().top - 20,
                // left: targetElement.offset().left - 30,
                top: top1,
                left: left1,
                background: back,
                "z-index": 999998,
                "box-shadow": "0 0 1px 10000px rgba(0, 0, 0, 0.6)",
            }).append($("<div>").css({
                position: "absolute",
                top: 0,
                bottom: 0,
                left: 0,
                right: 0
            })).appendTo($jpWalkthrough);
            if ($("#jpWalkthrough").length) {
                $("#jpWalkthrough").remove();
            }
            $jpWalkthrough.appendTo("body").show();
            $jpwTooltip.show();
            showTooltip();
        } else if (step.popup.type === "modal") {
            if ($("#jpWalkthrough").length) {
                $("#jpWalkthrough").remove();
            }
            showModal();
        } else {
            if ($("#jpWalkthrough").length) {
                $("#jpWalkthrough").remove();
            }
        }
        showButton("jpwPrevious");
        showButton("jpwNext");
        showButton("jpwFinish");
    }

    function showModal() {
        var options = _activeWalkthrough, step = options.steps[_index];
        $jpwOverlay.appendTo("body").show().removeClass("transparent");
        var textRotation = setRotation(parseInt(step.popup.contentRotation, 10));
        $jpwTooltip.css({
            position: "absolute",
            left: "45%",
            top: "25%",
            "margin-left": -(parseInt(step.popup.width, 10) + 60) / 2 + "px",
            "z-index": "999999"
        });
        var tooltipSlide = $('<div id="tooltipTop">' + '<div id="topLeft"></div>' + '<div id="topRight"></div>' + "</div>" + '<div id="tooltipInner">' + "</div>" + '<div id="tooltipBottom">' + '<div id="bottomLeft"></div>' + '<div id="bottomRight"></div>' + "</div>");
        $jpWalkthrough.html("");
        $jpwTooltip.html("").append(tooltipSlide).wrapInner($("<div />", {
            id: "tooltipWrapper",
            style: "width:" + cleanValue(parseInt(step.popup.width, 10) + 30)
        })).append('<div id="bottom-scratch"></div>').appendTo($jpWalkthrough);
        $jpWalkthrough.appendTo("body");
        $jpwTooltip.show();
        $("#tooltipWrapper").css(textRotation);
        $("#tooltipInner").append(getContent(step)).show();
        $jpWalkthrough.show();
    }

    function showTooltip() {
        var opt = _activeWalkthrough, step = opt.steps[_index];
        var top, left, arrowTop, arrowLeft, overlayHoleWidth = $("#jpWalkthrough .overlay-hole").outerWidth(),
            overlayHoleHeight = $("#jpWalkthrough .overlay-hole").outerHeight(),
            overlayHoleTop = $("#jpWalkthrough .overlay-hole").offset().top,
            overlayHoleLeft = $("#jpWalkthrough .overlay-hole").offset().left, arrow = 30;
        var textRotation = typeof step.popup.contentRotation === "undefined" || parseInt(step.popup.contentRotation, 10) === 0 ? clearRotation() : setRotation(parseInt(step.popup.contentRotation, 10));
        if ($("#jpwOverlay").length) {
            $("#jpwOverlay").addClass("transparent");
        }
        var tooltipSlide = $('<div id="tooltipTop">' + '<div id="topLeft"></div>' + '<div id="topRight"></div>' + "</div>" + '<div id="tooltipInner">' + "</div>" + '<div id="tooltipBottom">' + '<div id="bottomLeft"></div>' + '<div id="bottomRight"></div>' + "</div>");
        $jpwTooltip.html("").css({
            "margin-left": "0",
            "margin-top": "0",
            position: "absolute",
            "z-index": "999999"
        }).append(tooltipSlide).wrapInner($("<div />", {
            id: "tooltipWrapper",
            // style: "width:" + cleanValue(parseInt(step.popup.width, 10) + 30)
        })).appendTo($jpWalkthrough);
        $jpWalkthrough.appendTo("body").show();
        $("#tooltipWrapper").css(textRotation);
        $("#tooltipInner").append(getContent(step)).show();
        $jpwTooltip.append('<span class="' + step.popup.position + '">&nbsp;</span>');

        switch (step.popup.content) {
            case "#walkthrough-1":
                var leftVal = "320px";
                if(document.documentElement.clientWidth>1600){
                    leftVal = "400px";
                }
                $jpwTooltip.css({
                    position: "relative",
                    left: leftVal,
                    top: "-650px",
                });
                break;
            case "#walkthrough-2":
                var leftVal = "320px";
                if(document.documentElement.clientWidth>1600){
                    leftVal = "400px";
                }
                $jpwTooltip.css({
                    position: "relative",
                    left: leftVal,
                    top: "-700px",
                });
                break;
            case "#walkthrough-3":
                $jpwTooltip.css({
                    position: "relative",
                    left: "220px",
                    top: "-350px",
                });
                break;
            case "#walkthrough-4":
                $jpwTooltip.css({
                    position: "relative",
                    left: "210px",
                    top: "-1000px",
                    width:"600px"
                });
                break;
            case "#walkthrough-5":
                var leftVal = "520px";
                if(document.documentElement.clientWidth>1600){
                    leftVal = "700px";
                }
                $jpwTooltip.css({
                    position: "relative",
                    left: leftVal,
                    top: "-550px",
                });
                break;
            case "#walkthrough-6":
                var leftVal = "30px";
                if(document.documentElement.clientWidth>1600){
                    leftVal = "200px";
                }
                $jpwTooltip.css({
                    position: "relative",
                    left: leftVal,
                    top: "-700px",
                });
                break;
            case "#walkthrough-7":
                var leftVal = "0px";
                if(document.documentElement.clientWidth>1600){
                    leftVal = "150px";
                }
                $jpwTooltip.css({
                    position: "relative",
                    left: leftVal,
                    top: "-610px",
                });
                break;
            case "#walkthrough-8":
                var leftVal = "100px";
                if(document.documentElement.clientWidth>1600){
                    leftVal = "250px";
                }
                $jpwTooltip.css({
                    position: "relative",
                    left: leftVal,
                    top: "-600px",
                });
                break;

        }

        $jpWalkthrough.show();
    }

    function getContent(step) {
        var option = step.popup.content, content;
        try {
            content = $("body").find(option).html();
        } catch (e) {
        }
        return content || option;
    }

    function showButton(id, appendTo) {
        if ($("#" + id).length) {
            return;
        }
        var btn = _activeWalkthrough.buttons[id];
        appendTo = appendTo || "#tooltipWrapper";
        if (!btn) {
            return;
        }
        if (typeof btn.show === "function" && !btn.show() || !btn.show) {
            return;
        }
        $(appendTo).append($("<a />", {id: id, html: btn.i18n}));
    }

    function onCookieLoad(options) {
        for (var i = 0; i < _elements.length; i++) {
            if (typeof options[_elements[i]].onCookieLoad === "function") {
                options[_elements[i]].onCookieLoad.call(this);
            }
        }
        return false;
    }

    function onLeave(e) {
        var options = _activeWalkthrough;
        if (typeof options.steps[_index].onLeave === "function") {
            if (!options.steps[_index].onLeave.call(this, e, _index)) {
                return false;
            }
        }
        return true;
    }

    function onEnter(e) {
        var options = _activeWalkthrough;
        if (typeof options.steps[_index].onEnter === "function") {
            return options.steps[_index].onEnter.call(this, e, _index);
        }
        return true;
    }

    function onRestart(e) {
        var options = _activeWalkthrough;
        _isWalkthroughActive = true;
        methods.restart(e);
        if (typeof options.onRestart === "function") {
            if (!options.onRestart.call(this)) {
                return false;
            }
        }
        return true;
    }

    function onBeforeShow() {
        var options = _activeWalkthrough || {};
        _index = 0;
        if (typeof options.onBeforeShow === "function") {
            if (!options.onBeforeShow.call(this)) {
                return false;
            }
        }
        return true;
    }

    function onAfterShow() {
        var options = _activeWalkthrough;
        _index = 0;
        if (typeof options.onAfterShow === "function") {
            if (!options.onAfterShow.call(this)) {
                return false;
            }
        }
        return true;
    }

    function debug(message) {
        if (window.console && window.console.log) {
            window.console.log(message);
        }
    }

    function clearRotation() {
        var rotationStyle = {
            "-webkit-transform": "none",
            "-moz-transform": "none",
            "-o-transform": "none",
            filter: "none",
            "-ms-transform": "none"
        };
        return rotationStyle;
    }

    function setRotation(angle) {
        var M11, M12, M21, M22, deg2rad, rad;
        deg2rad = Math.PI * 2 / 360;
        rad = angle * deg2rad;
        // M11 = Math.cos(rad);
        // M12 = Math.sin(rad);
        // M21 = Math.sin(rad);
        // M22 = Math.cos(rad);
        var rotationStyle = {
            "-webkit-transform": "rotate(" + parseInt(angle, 10) + "deg)",
            "-moz-transform": "rotate(" + parseInt(angle, 10) + "deg)",
            "-o-transform": "rotate(" + parseInt(angle, 10) + "deg)",
            "-ms-transform": "rotate(" + parseInt(angle, 10) + "deg)"
        };
        return rotationStyle;
    }

    function cleanValue(value) {
        if (typeof value === "string") {
            if (value.toLowerCase().indexOf("px") === -1) {
                return value + "px";
            } else {
                return value;
            }
        } else {
            return value + "px";
        }
    }

    function setCookie(cName, value, exdays) {
        var exdate = new Date();
        exdate.setDate(exdate.getDate() + exdays);
//        var cValue = encodeURIComponent(value) + (exdays == null ? "" : "; expires=" + exdate.toUTCString());
//        document.cookie = [cName, "=", cValue].join("");
        var cValue = encodeURIComponent(value);
        if (document.URL.indexOf("https") != -1){
            document.cookie = cName + "="+ cValue + ";expires=" + exdate.toGMTString() + ";Secure;SameSite=Strict";
        } else {
            document.cookie = cName + "="+ cValue + ";expires=" + exdate.toGMTString();
        }
    }

    function getCookie(cName) {
        var i, x, y, ARRcookies = document.cookie.split(";");
        for (i = 0; i < ARRcookies.length; i++) {
            x = ARRcookies[i].substr(0, ARRcookies[i].indexOf("="));
            y = ARRcookies[i].substr(ARRcookies[i].indexOf("=") + 1);
            x = x.replace(/^\s+|\s+$/g, "");
            if (x === cName) {
                return decodeURIComponent(y);
            }
        }
    }

    function isLastStep() {
        return _index === _activeWalkthrough.steps.length - 1;
    }

    function isFirstStep() {
        return _index === 0;
    }

    function getScrollParent(element) {
        if (!(element instanceof $)) {
            element = $(element);
        }
        element = element.first();
        var position = element.css("position"), excludeStaticParent = position === "absolute",
            scrollParent = element.parents().filter(function () {
                var parent = $(this);
                if (excludeStaticParent && parent.css("position") === "static") {
                    return false;
                }
                return /(auto|scroll)/.test(parent.css("overflow") + parent.css("overflow-y") + parent.css("overflow-x"));
            }).eq(0);
        return position === "fixed" ? $() : !scrollParent.length ? $("body") : scrollParent;
    }

    $(document).on("click", "#jpwClose, #jpwFinish", methods.close);
    $(document).on("click", "#jpwNext", function () {
        $.pagewalkthrough("next");
    });
    $(document).on("click", "#jpwPrevious", function () {
        $.pagewalkthrough("prev");
    });
    $(document).on("click", "#jpwOverlay, #jpwTooltip", function (ev) {
        ev.stopPropagation();
        ev.stopImmediatePropagation();
    });
    $.pagewalkthrough = $.fn.pagewalkthrough = function (method) {
        if (methods[method]) {
            return methods[method].apply(this, [].slice.call(arguments, 1));
        } else if (typeof method === "object" || !method) {
            methods.init.apply(this, arguments);
            if (_hasDefault && _counter < 2) {
                setTimeout(function () {
                    methods.renderOverlay();
                }, 500);
            }
        } else {
            $.error("Method " + method + " does not exist on jQuery.pagewalkthrough");
        }
    };
    var jpwclose, jpwnext, jpwprevious, jpwfinish;
    function setValue(filename){
        // var url = require.resolve(filename);
		// $.getScript(url,function(){
		//     jpwclose = local.getJSLocale(wizardClose);
		//
        // });
    }
    $.fn.pagewalkthrough.defaults = {
        steps: [{
            wrapper: "",
            popup: {
                content: "",
                type: "modal",
                position: "top",
                offsetHorizontal: 0,
                offsetVertical: 0,
                offsetArrowHorizontal: 0,
                offsetArrowVertical: 0,
                width: "320",
                contentRotation: 0
            },
            autoScroll: true,
            scrollSpeed: 1e3,
            lockScrolling: false,
            onEnter: null,
            onLeave: null
        }],
        name: null,
        onLoad: true,
        onBeforeShow: null,
        onAfterShow: null,
        onRestart: null,
        onClose: null,
        onCookieLoad: null,
        buttons: {
            jpwClose: {i18n: "Click here to close", show: true},
            jpwNext: {
                i18n: "Next &rarr;", show: function () {
                    return !isLastStep();
                }
            },
            jpwPrevious: {
                i18n: "&larr; Previous", show: function () {
                    return !isFirstStep();
                }
            },
            jpwFinish: {
                i18n: "Finish &#10004;", show: function () {
                    return isLastStep();
                }
            }
        }
    };
    //remember language
    // var currentLang = document.cookie.getCookie("Slanguage");
    // $('#language').on("change",function() {
	// 	var sellanguage=document.getElementById("language").value;
	// 	selValue2(sellanguage);
    // });
    // if(currentLang===null||currentLang===""||currentLang==="null"||currentLang===undefined){
	//      currentLang = navigator.language;
    //
	//      if(!currentLang){
	//         currentLang = navigator.browserLanguage;
	//      }
    //     var filename = "";
	// 	switch(currentLang){
	// 		case "zh-cn":
	// 		case "zh-CN":{
	// 			filename="./locale_zh_CN.js";
	// 			selLanguage("Chinese");
	// 		}
	// 		break;
	// 		case "en-US":{
	// 			filename="./locale_en_US.js";
	// 			selLanguage("English");
	// 		}
	// 		break;
	// 		default:{
	// 			filename="./locale_en_US.js";
	// 			selLanguage("English");
	// 		}
	// 		break;
	// 	}
    //     setValue(filename);
	// }else{
	//      selLanguage(currentLang);
	//      selValue2(currentLang);
	// }
    // function selValue2(sellanguage){
    //     if(sellanguage=="English"){
    //         setValue('../i18n/locale_en_US');
    //     }
    //     else if(sellanguage=="Chinese"){
    //         setValue('../i18n/locale_zh_CN');
    //     }
    //     else if(sellanguage=="Portuguese"){
    //         setValue('../i18n/locale_pt_BR');
    //     }
    //     else if(sellanguage=="French"){
    //         setValue('../i18n/locale_fr_FR');
    //     }
    //     else if(sellanguage=="Germany"){
    //         setValue('../i18n/locale_de_DE');
    //     }
    //     else if(sellanguage=="Italian"){
    //         setValue('../i18n/locale_it_IT');
    //     }
    //     else if(sellanguage=="Japanese"){
    //         setValue('../i18n/locale_ja_JP');
    //     }
    //     else if(sellanguage=="Korean"){
    //         setValue('../i18n/locale_ko_KR');
    //     }
    //     else if(sellanguage=="Spanish"){
    //         setValue('../i18n/locale_es_ES');
    //     }
    //     else if(sellanguage=="TraditionalChinese"){
    //         setValue('../i18n/locale_zh_TW');
    //     }
    // }
    // function selLanguage(language) {
    //     var str = document.getElementById("language").options;
    //     for(var i=str.length-1;i>=0;i--) {
    //         if (str[i].value==language) {
    //             str[i].selected = true;
    //             break;
    //         }
    //     }
    // }
})($, window, document);